﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;

namespace DrHeet.SportsRadar.WCFClient
{
    public partial class SpeedMonitorForm : Form
    {
        private SportRadarDCSClient client = null;
        private Guid clientId;
        delegate void SetTextCallback(string text);

        public SpeedMonitorForm()
        {
            InitializeComponent();
            InstanceContext context = new InstanceContext(new SportsRadarCallback());
            client = new SportRadarDCSClient(context);

            clientId = client.SubscribeSpeedEvent("Windows Forms Client");

            this.AddLine("Service endpoint: "+client.Endpoint.Address.ToString());
        }

        public void Unsubscribe()
        {
            try
            {
                client.UnsubscribeSpeedEvent(clientId);
            }
            catch (Exception e)
            {
                this.AddLine("Unable to unsubscribe from Service");
            }
        }

        private void SpeedMonitorForm_Load(object sender, EventArgs e)
        {
        
        }

        private void SpeedLabel_Click(object sender, EventArgs e)
        {
        
        }

        private void listBox_TextChanged(object sender, EventArgs e)
        {
        
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Unsubscribe();
            this.Close();
        }

        public void SetSpeedLabel(string text)
        {
            SpeedLabel.Text = text;
        }

        public void AddLine(string text)
        {
            AddText(text + Environment.NewLine);
        }

        public void AddText(string text)
        {
            if (this.listBox.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(AddText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.listBox.AppendText(text);
            }
        }

    }
}
