﻿ SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[SR3600_fn_MPHSpeedBands]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[SR3600_fn_MPHSpeedBands]
GO


/*	Test: 
	use dcs
	go
	declare @start datetime
	set @start = getdate();
	
	select * from [SR3600_fn_MPHSpeedBands] (@start);
*/

CREATE FUNCTION [dbo].[SR3600_fn_MPHSpeedBands]
(
	@theDate datetime
)
RETURNS TABLE
AS
RETURN
(
		select 
			convert(datetime, convert(varchar(10), @theDate, 101)) as [theDate],
			pvt.*
		from
		(
			select 
				convert(int, round(dcs_speed_mph, 0)/5) as speed_band
			from 
				[dbo].[SR3600Data]
			where 
				dcs_time between convert(datetime, convert(varchar(10), @theDate, 101))  and convert(datetime, convert(varchar(10), @theDate, 101)) + 1
		) p
		pivot
		(
			COUNT (speed_band)
			FOR speed_band IN
			( [0], [1], [2], [3], [4], [5], [6], [7], [8], [9], [10], [11], [12], [13], [14])
		) AS pvt
)
GO


