﻿SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[SR3600_fn_MPHTimeBands]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[SR3600_fn_MPHTimeBands]
GO

/*	Test: 
	declare @start datetime
	set @start = getdate();
	
	select * from [SR3600_fn_MPHTimeBands] (@start);
*/

CREATE FUNCTION [dbo].[SR3600_fn_MPHTimeBands]
(
	@theDate datetime
)
RETURNS TABLE
AS
RETURN
(
		select 
			convert(datetime, convert(varchar(10), @theDate, 101)) as [theDate],
			pvt.*
		from
		(
			select 
				datepart(hh, dcs_time) as hour,
				dcs_speed_mph
			from 
				[dbo].[SR3600Data]
			where 
				dcs_time between convert(datetime, convert(varchar(10), @theDate, 101))  and convert(datetime, convert(varchar(10), @theDate, 101)) + 1
		) p
		pivot
		(
			COUNT (dcs_speed_mph)
			FOR hour IN
			( [0], [1], [2], [3], [4], [5], [6], [7], [8], [9],[10], [11], [12], [13], [14],[15], [16], [17], [18], [19],[20], [21], [22], [23])
		) AS pvt
)
GO

