﻿SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[SR3600_sp_MPHStatistics]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[SR3600_sp_MPHStatistics]
GO


CREATE PROCEDURE [dbo].[SR3600_sp_MPHStatistics]
	@lowerLimit datetime,
	@upperlimit	datetime,
	@speedlimit	float
AS
BEGIN
	select 
		 [begin_period]
		,[end_period]
		,[count_all]
		,[count_speeders]
		,[count_10mph_speeders]
		,[count_20mph_speeders]
		,[pct_speeders]
		,[average_speed_above_limit]
		,[average_speed_pct_above_limit]
		,[average_speed]
		,[max_speed]
		,[last_speed]
		,[all_time_max_speed]
		,[bad_readings]
	from [SR3600_fn_MPHStatistics] (@lowerLimit, @upperlimit, @speedlimit);
END
GO
 