﻿USE [DCS]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[SR3600DataSeries]') AND type in (N'U'))
DROP TABLE [dbo].[SR3600DataSeries]
GO

CREATE TABLE [DCS].[dbo].[SR3600DataSeries]
(
	  [series_id] int identity
	 ,[system_name] nvarchar(1024) not null
     ,[start_date] datetime not null
     ,[end_date] datetime null
     ,[calibration_factor] numeric(6,2) not null
     ,[channel_name] nvarchar(1024) not null
     ,[property_id] int
     ,[property_description] nvarchar(1024) 
     ,[data_points] int null
	 ,CONSTRAINT [PK_SR3600DataSeries] PRIMARY KEY CLUSTERED 
	 (
		[series_id] ASC
	 )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
);
GO


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[SR3600Data]') AND type in (N'U'))
DROP TABLE [dbo].[SR3600Data]
GO

CREATE TABLE [DCS].[dbo].[SR3600Data]
(
	 [data_id] int identity
	,[series_id] int not null
	,[dcs_time] datetime not null
	,[dcs_speed_mph] numeric(6,1)
	,[dcs_speed_kph] numeric(6,1)
	,[comment] nvarchar(256) 
	,CONSTRAINT [PK_SR3600Data] PRIMARY KEY CLUSTERED 
	(	
		[data_id] ASC
	)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
);

GO


CREATE NONCLUSTERED INDEX [IX_SR3600Data_Time] ON [dbo].[SR3600Data] 
(
	[dcs_time] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = OFF) ON [PRIMARY]
GO