﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data.Common;
using System.Data.SqlClient;
using System.Configuration;

namespace DrHeet.SportsRadarWS
{
    /// <summary>
    /// Summary description for Service1
    /// </summary>
    [WebService(Namespace = "http://shuttle:80")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]

    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    [System.Web.Script.Services.ScriptService]
    public class SR3600Statistics : System.Web.Services.WebService
    {

        /// <summary>The SR3600Statistics struct holds a complete set of statistics.</summary>
        public struct SR3600StatisticsData
        {
            public DateTime BeginPeriod;
            public DateTime EndPeriod;
            public int CountAll;
            public int CountSpeeders;
            public int Count10mphSpeeders;
            public int Count20mphSpeeders;
            public double PctSpeeders;
            public double AverageSpeedAboveLimit;
            public double AverageSpeedPctAboveLimit;
            public double AverageSpeed;
            public double MaxSpeed;
            public double LastSpeed;
            public double AllTimeMaxSpeed;
            public int SpeedLimit;
            public int BadReadings;
        }

        public struct SR3600TimeBandData
        {
            public DateTime TheDate;
            public int h0;
            public int h1;
            public int h2;
            public int h3;
            public int h4;
            public int h5;
            public int h6;
            public int h7;
            public int h8;
            public int h9;
            public int h10;
            public int h11;
            public int h12;
            public int h13;
            public int h14;
            public int h15;
            public int h16;
            public int h17;
            public int h18;
            public int h19;
            public int h20;
            public int h21;
            public int h22;
            public int h23;
        }

        public struct SR3600SpeedBandData
        {
            public DateTime TheDate;
            public int s0;
            public int s1;
            public int s2;
            public int s3;
            public int s4;
            public int s5;
            public int s6;
            public int s7;
            public int s8;
            public int s9;
            public int s10;
            public int s11;
            public int s12;
            public int s13;
            public int s14;
        }

        public struct SR3600HourlySpeedData
        {
            public DateTime TheDate;
            public int h0;
            public int h1;
            public int h2;
            public int h3;
            public int h4;
            public int h5;
            public int h6;
            public int h7;
            public int h8;
            public int h9;
            public int h10;
            public int h11;
            public int h12;
            public int h13;
            public int h14;
            public int h15;
            public int h16;
            public int h17;
            public int h18;
            public int h19;
            public int h20;
            public int h21;
            public int h22;
            public int h23;
        }

        [WebMethod]
        public SR3600StatisticsData SP3600Statistics24Hours(int speedLimit)
        {
            SR3600StatisticsData s = new SR3600StatisticsData();

            string connStr = ConfigurationManager.ConnectionStrings["SportsRadarDCS"].ConnectionString;

            // we do not keep the connection open
            using (SqlConnection connection = new SqlConnection(connStr))
            {
                System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand();
                cmd.CommandType = System.Data.CommandType.Text;
                cmd.CommandText = "select * from [dbo].[SR3600_fn_MPHStatistics] (@start, @end, @limit);";

                cmd.Parameters.Add(new SqlParameter("@start", DateTime.Now.AddDays(-1)));
                cmd.Parameters.Add(new SqlParameter("@end", DateTime.Now));
                cmd.Parameters.Add(new SqlParameter("@limit", speedLimit));

                cmd.Connection = connection;

                connection.Open();

                SqlDataReader r = cmd.ExecuteReader();
                if (r.Read())
                {
                    s.BeginPeriod = (DateTime)r["begin_period"];
                    s.EndPeriod = (DateTime)r["end_period"];
                    s.CountAll = (int)r["count_all"];
                    s.CountSpeeders = (int)r["count_speeders"];
                    s.Count10mphSpeeders = (int)r["count_10mph_speeders"];
                    s.Count20mphSpeeders = (int)r["count_20mph_speeders"];
                    s.PctSpeeders = decimal.ToDouble((decimal)(r["pct_speeders"]));
                    s.AverageSpeedAboveLimit = (double)(r["average_speed_above_limit"]);
                    s.AverageSpeedPctAboveLimit = (double)(r["average_speed_pct_above_limit"]);
                    s.AverageSpeed = decimal.ToDouble((decimal)(r["average_speed"]));
                    s.MaxSpeed = decimal.ToDouble((decimal)(r["max_speed"]));
                    s.LastSpeed = decimal.ToDouble((decimal)(r["last_speed"]));
                    s.AllTimeMaxSpeed = decimal.ToDouble((decimal)(r["all_time_max_speed"]));
                    s.SpeedLimit = (int)((double)(r["speed_limit"]));
                    s.BadReadings = (int)r["bad_readings"];
                }
                else
                    throw (new Exception("No data found."));

                connection.Close();
            }

            return s;
        }



        [WebMethod]
        public SR3600TimeBandData SP3600TimeBands24Hours()
        {
            SR3600TimeBandData t = new SR3600TimeBandData();

            string connStr = ConfigurationManager.ConnectionStrings["SportsRadarDCS"].ConnectionString;

            // we do not keep the connection open
            using (SqlConnection connection = new SqlConnection(connStr))
            {
                System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand();
                cmd.CommandType = System.Data.CommandType.Text;
                cmd.CommandText = "select * from [dbo].[SR3600_fn_MPHTimeBands] (@theDate);";

                cmd.Parameters.Add(new SqlParameter("@theDate", DateTime.Now.AddDays(-1)));

                cmd.Connection = connection;

                connection.Open();

                SqlDataReader r = cmd.ExecuteReader();
                if (r.Read())
                {
                    t.TheDate = (DateTime)r["theDate"];
                    t.h0 = (int)r["0"];
                    t.h1 = (int)r["1"];
                    t.h2 = (int)r["2"];
                    t.h3 = (int)r["3"];
                    t.h4 = (int)r["4"];
                    t.h5 = (int)r["5"];
                    t.h6 = (int)r["6"];
                    t.h7 = (int)r["7"];
                    t.h8 = (int)r["8"];
                    t.h9 = (int)r["9"];
                    t.h10 = (int)r["10"];
                    t.h11 = (int)r["11"];
                    t.h12 = (int)r["12"];
                    t.h13 = (int)r["13"];
                    t.h14 = (int)r["14"];
                    t.h15 = (int)r["15"];
                    t.h16 = (int)r["16"];
                    t.h17 = (int)r["17"];
                    t.h18 = (int)r["18"];
                    t.h19 = (int)r["19"];
                    t.h20 = (int)r["20"];
                    t.h21 = (int)r["21"];
                    t.h22 = (int)r["22"];
                    t.h23 = (int)r["23"];
                }
                else
                    throw (new Exception("No data found."));

                connection.Close();
            }

            return t;
        }

        [WebMethod]
        public SR3600SpeedBandData SP3600SpeedBands24Hours()
        {
            SR3600SpeedBandData s = new SR3600SpeedBandData();

            string connStr = ConfigurationManager.ConnectionStrings["SportsRadarDCS"].ConnectionString;

            // we do not keep the connection open
            using (SqlConnection connection = new SqlConnection(connStr))
            {
                System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand();
                cmd.CommandType = System.Data.CommandType.Text;
                cmd.CommandText = "select * from [dbo].[SR3600_fn_MPHSpeedBands] (@theDate);";

                cmd.Parameters.Add(new SqlParameter("@theDate", DateTime.Now.AddDays(-1)));

                cmd.Connection = connection;

                connection.Open();

                SqlDataReader r = cmd.ExecuteReader();
                if (r.Read())
                {
                    s.TheDate = (DateTime)r["theDate"];
                    s.s0 = (int)r["0"];
                    s.s1 = (int)r["1"];
                    s.s2 = (int)r["2"];
                    s.s3 = (int)r["3"];
                    s.s4 = (int)r["4"];
                    s.s5 = (int)r["5"];
                    s.s6 = (int)r["6"];
                    s.s7 = (int)r["7"];
                    s.s8 = (int)r["8"];
                    s.s9 = (int)r["9"];
                    s.s10 = (int)r["10"];
                    s.s11 = (int)r["11"];
                    s.s12 = (int)r["12"];
                    s.s13 = (int)r["13"];
                    s.s14 = (int)r["14"];
                }
                else
                    throw (new Exception("No data found."));

                connection.Close();
            }

            return s;
        }



        [WebMethod]
        public SR3600HourlySpeedData SP3600HourlySpeed24Hours()
        {
            SR3600HourlySpeedData s = new SR3600HourlySpeedData();

            string connStr = ConfigurationManager.ConnectionStrings["SportsRadarDCS"].ConnectionString;

            // we do not keep the connection open
            using (SqlConnection connection = new SqlConnection(connStr))
            {
                System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand();
                cmd.CommandType = System.Data.CommandType.Text;
                cmd.CommandText = "select * from [dbo].[SR3600_fn_MPHAvgTimeBands] (@theDate);";

                cmd.Parameters.Add(new SqlParameter("@theDate", DateTime.Now.AddDays(-1)));

                cmd.Connection = connection;

                connection.Open();

                SqlDataReader r = cmd.ExecuteReader();
                if (r.Read())
                {
                    try
                    {
                        s.TheDate = (DateTime)r["theDate"];
                        s.h0 = FormatSpeedValue(r["0"]);
                        s.h1 = FormatSpeedValue(r["1"]);
                        s.h2 = FormatSpeedValue(r["2"]);
                        s.h3 = FormatSpeedValue(r["3"]);
                        s.h4 = FormatSpeedValue(r["4"]);
                        s.h5 = FormatSpeedValue(r["5"]);
                        s.h6 = FormatSpeedValue(r["6"]);
                        s.h7 = FormatSpeedValue(r["7"]);
                        s.h8 = FormatSpeedValue(r["8"]);
                        s.h9 = FormatSpeedValue(r["9"]);
                        s.h10 = FormatSpeedValue(r["10"]);
                        s.h11 = FormatSpeedValue(r["11"]);
                        s.h12 = FormatSpeedValue(r["12"]);
                        s.h13 = FormatSpeedValue(r["13"]);
                        s.h14 = FormatSpeedValue(r["14"]);
                        s.h15 = FormatSpeedValue(r["15"]);
                        s.h16 = FormatSpeedValue(r["16"]);
                        s.h17 = FormatSpeedValue(r["17"]);
                        s.h18 = FormatSpeedValue(r["18"]);
                        s.h19 = FormatSpeedValue(r["19"]);
                        s.h20 = FormatSpeedValue(r["20"]);
                        s.h21 = FormatSpeedValue(r["21"]);
                        s.h22 = FormatSpeedValue(r["22"]);
                        s.h23 = FormatSpeedValue(r["23"]);
                    }
                    catch (Exception e)
                    {
                        throw (new Exception("Data read error: "+e.Message));
                    }
                }
                else
                    throw (new Exception("No data found."));

                connection.Close();
            }

            return s;
        }


        private static int FormatSpeedValue(object input)
        {
            if (input != System.DBNull.Value)
                return (int)Math.Round((decimal) input);
            else
                return 0;
    	}
    }
}
