﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;


namespace DrHeet.SportsRadarWeb
{
    public partial class _Default : System.Web.UI.Page
    {
        SR3600WS.SR3600StatisticsData sd;
        SR3600WS.SR3600TimeBandData tb;
        SR3600WS.SR3600SpeedBandData sp;
        SR3600WS.SR3600HourlySpeedData hs;
        SR3600WS.SR3600Statistics srws = new SR3600WS.SR3600Statistics();

       
        protected void Page_Load(object sender, EventArgs e)
        {
            sd = srws.SP3600Statistics24Hours(30);
            tb = srws.SP3600TimeBands24Hours();
            sp = srws.SP3600SpeedBands24Hours();
            hs = srws.SP3600HourlySpeed24Hours();

            BeginPeriod.Text = sd.BeginPeriod.ToShortDateString() + " " + sd.BeginPeriod.ToShortTimeString();
            EndPeriod.Text = sd.EndPeriod.ToShortDateString() + " " + sd.EndPeriod.ToShortTimeString();
            Yesterday.Text = sd.BeginPeriod.ToShortDateString();

            SpeedLimit.Text = sd.SpeedLimit.ToString();
            AverageSpeed.Text = sd.AverageSpeed.ToString("0.0");
            AllTimeMaxSpeed.Text = sd.AllTimeMaxSpeed.ToString("0.0");
            AverageSpeedAboveLimit.Text = sd.AverageSpeedAboveLimit.ToString("0.0");
            AverageSpeedPctAboveLimit.Text = sd.AverageSpeedPctAboveLimit.ToString("0.0");
            Count10mphSpeeders.Text = sd.Count10mphSpeeders.ToString();
            Pct10mphSpeeders.Text = ((sd.Count10mphSpeeders*100)/sd.CountAll).ToString();
            Count20mphSpeeders.Text = sd.Count20mphSpeeders.ToString();
            Pct20mphSpeeders.Text = ((sd.Count20mphSpeeders * 100) / sd.CountAll).ToString();
            CountAll.Text = sd.CountAll.ToString();
            PctSpeeders.Text = sd.PctSpeeders.ToString("0.0");
            CountSpeeders.Text = sd.CountSpeeders.ToString();
            MaxSpeed.Text = sd.MaxSpeed.ToString();
            LastSpeed.Text = sd.LastSpeed.ToString();
            AllTimeMaxSpeed.Text = sd.AllTimeMaxSpeed.ToString();
            BadReadings.Text = sd.BadReadings.ToString();

            SpeedDist.Src = "http://chart.apis.google.com/chart?cht=p3&chs=450x200&chtt=24+Hour+Speed+Distribution" +
                "&chts=0000FF,15&chd=t:" +
                ((sd.CountAll - sd.CountSpeeders) * 100 / sd.CountAll).ToString() + "," +
                ((sd.CountSpeeders - sd.Count10mphSpeeders) * 100 / sd.CountAll).ToString() + "," +
                ((sd.Count10mphSpeeders - sd.Count20mphSpeeders) * 100 / sd.CountAll).ToString()+","+
                ((sd.Count20mphSpeeders) * 100 / sd.CountAll).ToString()+
                "&chl=under%2030mph|30mph-40mph|40mph-50mph|over%2050mph";

            TimeBands.Src = "http://chart.apis.google.com/chart?cht=bvg&chbh=9,5&chs=450x170&chg=10,20&chco=4d89f9&chxt=x,y,x&chxr=0,0,23&chtt=Hourly%20Vehicle%20Frequency%20" +
                tb.TheDate.ToShortDateString() +
                "&chxl=2:|||||||||||||Time of day|" +                     // Todo: chart scale - make this dynamic so that it works with busy streets
                "&chts=0000FF,15&chd=t:" +
                tb.h0.ToString() + "," +
                tb.h1.ToString() + "," +
                tb.h2.ToString() + "," +
                tb.h3.ToString() + "," +
                tb.h4.ToString() + "," +
                tb.h5.ToString() + "," +
                tb.h6.ToString() + "," +
                tb.h7.ToString() + "," +
                tb.h8.ToString() + "," +
                tb.h9.ToString() + "," +
                tb.h10.ToString() + "," +
                tb.h11.ToString() + "," +
                tb.h12.ToString() + "," +
                tb.h13.ToString() + "," +
                tb.h14.ToString() + "," +
                tb.h15.ToString() + "," +
                tb.h16.ToString() + "," +
                tb.h17.ToString() + "," +
                tb.h18.ToString() + "," +
                tb.h19.ToString() + "," +
                tb.h20.ToString() + "," +
                tb.h21.ToString() + "," +
                tb.h22.ToString() + "," +
                tb.h23.ToString();

            SpeedDetail.Src = "http://chart.apis.google.com/chart?cht=lc&chbh=9,5&chs=450x200&chg=10,20&chco=4d89f9&chxt=x,x&chxr=0,0,70&chtt=Detailed+Speed+Distribution+" +
                sp.TheDate.ToShortDateString() +
                "&chxl=1:||mph|" +                     // Todo: chart scale - make this dynamic so that it works with busy streets
                "&chds=0,400" +                     // Todo: chart scale - make this dynamic so that it works with busy streets
                "&chm=R,ff0000,0,.425,0.432" +      // Red line: make this dynamic so that it uses the speed limit
                "&chts=0000FF,15&chd=t:" +
                sp.s0.ToString() + "," +
                sp.s1.ToString() + "," +
                sp.s2.ToString() + "," +
                sp.s3.ToString() + "," +
                sp.s4.ToString() + "," +
                sp.s5.ToString() + "," +
                sp.s6.ToString() + "," +
                sp.s7.ToString() + "," +
                sp.s8.ToString() + "," +
                sp.s9.ToString() + "," +
                sp.s10.ToString() + "," +
                sp.s11.ToString() + "," +
                sp.s12.ToString() + "," +
                sp.s13.ToString() + "," +
                sp.s14.ToString();

            SpeedByHour.Src = "http://chart.apis.google.com/chart?cht=bvg&chbh=9,5&chs=450x170&chg=10,20&chco=4d89f9&chxt=x,y,x&chxr=0,0,23|1,20,50&chtt=Hourly%20Speed%20Averages%20" +
                hs.TheDate.ToShortDateString() +
                "&chxl=2:|||||||||||||Time of day|" +                     // Todo: chart scale - make this dynamic so that it works with busy streets
                "&chds=20,50" +                     // Todo: chart scale - make this dynamic so that it works with busy streets
                "&chts=0000FF,15&chd=t:" +
                hs.h0.ToString() + "," +
                hs.h1.ToString() + "," +
                hs.h2.ToString() + "," +
                hs.h3.ToString() + "," +
                hs.h4.ToString() + "," +
                hs.h5.ToString() + "," +
                hs.h6.ToString() + "," +
                hs.h7.ToString() + "," +
                hs.h8.ToString() + "," +
                hs.h9.ToString() + "," +
                hs.h10.ToString() + "," +
                hs.h11.ToString() + "," +
                hs.h12.ToString() + "," +
                hs.h13.ToString() + "," +
                hs.h14.ToString() + "," +
                hs.h15.ToString() + "," +
                hs.h16.ToString() + "," +
                hs.h17.ToString() + "," +
                hs.h18.ToString() + "," +
                hs.h19.ToString() + "," +
                hs.h20.ToString() + "," +
                hs.h21.ToString() + "," +
                hs.h22.ToString() + "," +
                hs.h23.ToString();
        }
    }
}
